<?php
/*------------------------------------------------------------------------
# urednidesk.php - Úřední deska Component
# ------------------------------------------------------------------------
# author    Petr Houba
# copyright Copyright (C) 2013. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   urednideska.g6.cz
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// import Joomla controllerform library
jimport('joomla.application.component.controllerform');

/**
 * Urednideska Controller Upravakategorie
 */
class UrednideskaControllerUpravakategorie extends JControllerForm { 
	
  protected $text_prefix = 'COM_UREDNIDESKA_CATEGORIES';
  
  function __construct($config = array()) {
    $app = JFactory::getApplication();
    
    $this->view_list = 'upravakategorie';

    if (JRequest::getCmd('task') == 'cancel' || JRequest::getCmd('task') == 'save') {
			$this->view_list = 'kategorie';
		}
    
    if (JRequest::getCmd('task') == 'edit') {
      $categoryId = JRequest::getVar('cid', JRequest::getInt('id'), 'post', 'array');
      $allowEdit = JFactory::getUser()->authorise('core.edit', 'com_urednideska.kategorie.'.$categoryId[0]);
        
      if($allowEdit === false) {
        $app->enqueueMessage(JText::_('COM_UREDNIDESKA_PERMISSION_CATEGORIES_EDIT'), 'notice');
        $link = 'index.php?option=com_urednideska&view=kategorie';
        $app->redirect($link);
      }
    }  

		parent::__construct($config);
	}
  
  function delete() {
    JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
    $app = JFactory::getApplication();
    $db = & JFactory::getDBO();
    $query = $db->getQuery(true);
    
    // Get the model.
		$model = $this->getModel();
    
    $cid = JRequest::getVar('cid', '', '', 'array');

    /*$where = ' WHERE catid IN('.implode($cid,',').')';
    $where_kat = ' WHERE id IN('.implode($cid,',').')';*/
    
    $query->clear();
    $query->select(array($db->quoteName('id'), $db->quoteName('title')));
    $query->from($db->quoteName('#__urednideska_kategorie'));
    $query->where('id IN('.implode($cid,',').')');
    $db->setQuery($query);
    
    $rows = $db->loadObjectList();

    $i = 0;
    foreach ($rows AS $row) {
      $canDelete = $model->canDelete($row);
      
      if ($canDelete) {      
        $query->clear();
        $query->select('COUNT('.$db->quoteName('id').')');
        $query->from($db->quoteName('#__urednideska'));
        $query->where('catid = '. $row->id);
        $db->setQuery($query);
        
        $count = $db->loadResult();
    		
        if ($count != 0) { 
          $app->enqueueMessage(sprintf(JText::_('COM_UREDNIDESKA_CATEGORIES_DELETE_NO_EMPTY'), $row->id), 'notice');
        }
        else {              
          $query->clear();
          $query->delete('#__urednideska_kategorie');
          $query->where('id = '.$row->id);
          $db->setQuery($query);
          $db->query();
      
          // Check for a database error.
      		if ($db->getErrorNum()) {
      			$app->enqueueMessage(sprintf(JText::_('COM_UREDNIDESKA_CATEGORIES_DELETE_DB_ERROR'), $row->id), 'error');
            $app->enqueueMessage($db->getErrorMsg());
      		}
          else {
            $i++;
          }
        }
      }
      else {
        $app->enqueueMessage(sprintf(JText::_('COM_UREDNIDESKA_PERMISSION_CATEGORIES_DELETE'), $row->id), 'notice');
      }
    }
    
    if($i > 0) {
      $app->enqueueMessage(JText::plural('COM_UREDNIDESKA_CATEGORIES_N_ITEMS_DELETED', $i));
    }
    $link = 'index.php?option=com_urednideska&view=kategorie';
    $this->setRedirect($link);   
  }
}
?>