<?php
/*------------------------------------------------------------------------
# urednidesk.php - Úřední deska Component
# ------------------------------------------------------------------------
# author    Petr Houba
# copyright Copyright (C) 2013. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   urednideska.g6.cz
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// import Joomla controllerform library
jimport('joomla.application.component.controllerform');
jimport('joomla.application.component.helper');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

/**
 * Urednideska Controller Upravazaznamu
 */
class UrednideskaControllerUpravazaznamu extends JControllerForm { 
	
  protected $text_prefix = 'COM_UREDNIDESKA_ITEM_EDIT';
  
  function __construct($config = array()) {
    if (JRequest::getCmd('task') == 'cancel' || JRequest::getCmd('task') == 'save') {
			$this->view_list = 'urednideska';
		}
    
		parent::__construct($config);
	}
  
  function delete () {
    // Check for request forgeries
		JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));
    $app = JFactory::getApplication();
    $params	= &JComponentHelper::getParams('com_urednideska');
    
    // Get the model.
		$model = $this->getModel();
    
    // Get items to publish from the request.
		$cid = JRequest::getVar('cid', array(), '', 'array');
    
    if (empty($cid)) {
			JError::raiseWarning(500, JText::_('COM_UREDNIDESKA_NO_ITEM_SELECTED'));
		}
    else {
      $db	=& JFactory::getDBO();
      $query = $db->getQuery(true);
      
      $query->select('id, catid, state');
      $query->from('#__urednideska');
      $query->where('id IN('.implode($cid, ',').')');
      $db->setQuery((string)$query);
      $rows = $db->loadObjectList();
    
      foreach ($rows AS $row) {
        $canDelete = $model->canDelete($row);
        
        if ($canDelete) {        
          if ($row->state == -1 && $params->get('mazat_archiv', 0) == 0) { 
            $app->enqueueMessage(sprintf(JText::_('COM_UREDNIDESKA_ALERT_ITEMS_ARCHIVE_DELETE'), $row->id), 'notice');  
          }
          else {
            $query->clear();
            $query->select('*');
            $query->from('#__urednideska_files');
            $query->where('pid = '.$row->id);
            $db->setQuery($query);
            $rowsfile = $db->loadObjectList();
            
            if (!empty($rowsfile)) {
              $file = array();
          		$dir = JPATH_SITE.DS.$params->get('adresar', '');
              foreach ($rowsfile AS $rowfile) {
                if ($rowfile->file != '') { 
                  $files[] = $dir.$rowfile->pid.'-'.$rowfile->filename.'.'.$rowfile->extension;
                }        
              }
              JFile::delete($files);
              
              $query->clear();
              $query->delete('#__urednideska_files')->where('pid = '.$row->id);
              $db->setQuery($query);
              $db->query();
            }
            
            $query->clear();
            $query->delete('#__urednideska')->where('id = '.$row->id);
            $db->setQuery($query);
            if ($db->query()) {
              $app->enqueueMessage(sprintf(JText::_('COM_UREDNIDESKA_ALERT_ITEM_DELETE'), $row->id));
            }
            else {
              $app->enqueueMessage(sprintf(JText::_('COM_UREDNIDESKA_ALERT_ITEM_NO_DELETE'), $row->id), 'error');
              $app->enqueueMessage($db->getErrorMsg(), 'error');
            }    
          }
        }
        else {
          $app->enqueueMessage(sprintf(JText::_('COM_UREDNIDESKA_PERMISSION_ITEM_DELETE'), $row->id), 'notice');
        }   
      }
      
            
      $link = 'index.php?option=com_urednideska&view=urednideska';
      $this->setRedirect($link); 
    }
  }
  
  function filelist() {
    $app = JFactory::getApplication();
    $db		= JFactory::getDbo();
    
    $params = JComponentHelper::getParams('com_urednideska');
    $id = JRequest::getInt('id', 0);
		$query	= $db->getQuery(true);

		$query->select('*');
		$query->from('#__urednideska_files');
		$query->where('pid = '.$id);
    $query->order('ordering');

		// Get the options.
		$db->setQuery($query);

		$rows = $db->loadObjectList();

		// Check for a database error.
		if ($db->getErrorNum()) {
			JError::raiseWarning(500, $db->getErrorMsg());
		}
    
    $output = '';
    $folder = $params->get('adresar', 'dokumenty'.DS);
    if (count($rows) > 0) {
      $folderpath = JURI::root(true).'/'.$folder;
      /*$output .= '<table class="table" width="100%"><tr><th style="width: 20px"></th><th>'.JText::_('COM_UREDNIDESKA_ITEM_UPLOAD_FILE').'</th><th width="50">'.JText::_('COM_UREDNIDESKA_ITEM_UPLOAD_FILESIZE').'</th><th width="20"></th></tr>';
      foreach($rows AS $k => $row) {
        $filename = $row->pid.'-'.$row->filename.'.'.$row->extension;
        $filesize = filesize(JPATH_ROOT.DS.$folder.$filename);
        $output .= '<tr>';
        $output .= '<td>'.UrednideskaHelper::ikona($row->extension, $row->filename).'</td>';
        if ($row->extension == 'jpg' || $row->extension == 'gif' || $row->extension == 'png') { 
          $output .= '<td><a class="modal-ud" href="'.$folderpath.$filename.'" rel="{size: {x: 800, y: 500}}">'.$row->file.'</a></td>';
        }
        else {
          $output .= '<td><a href="'.$folderpath.$filename.'" target="_blank">'.$row->file.'</a></td>';
        }
        $output .= '<td class="right">'.UrednideskaHelper::format_bytes($filesize).'</td>';
        $output .= '<td class="right"><a href="javascript:void(0)" onclick="deletefile('.$row->id.')"><img src="components/com_urednideska/assets/images/delete.png" width="16" title="'.JText::_('COM_UREDNIDESKA_FILE_DELETE').'"/></a></td>';
        $output .= '</tr>';
      }
      $output .= '</table>'; */
      
      $output .= '<ul id="sortable">';
      foreach($rows AS $k => $row) {
        $filename = $row->pid.'-'.$row->filename.'.'.$row->extension;
        $filesize = filesize(JPATH_ROOT.DS.$folder.$filename);
        $output .= '<li rel="'.$row->id.'">';
        $output .= '<div style="width: 6%">'.UrednideskaHelper::ikona($row->extension, $row->filename).'</div>';
        if ($row->extension == 'jpg' || $row->extension == 'gif' || $row->extension == 'png') { 
          $output .= '<div <div style="width: 73%"><a class="modal-ud" href="'.$folderpath.$filename.'" rel="{size: {x: 800, y: 500}}">'.$row->file.'</a></div>';
        }
        else {
          $output .= '<div style="width: 73%;"><a href="'.$folderpath.$filename.'" target="_blank">'.$row->file.'</a></div>';
        }
        $output .= '<div class="right" style="width: 15%">'.UrednideskaHelper::format_bytes($filesize).'</div>';
        $output .= '<div class="right"  style="width: 6%"><a href="javascript:void(0)" onclick="deletefile('.$row->id.')"><img src="components/com_urednideska/assets/images/delete.png" width="16" title="'.JText::_('COM_UREDNIDESKA_FILE_DELETE').'"/></a></div>';
        $output .= '</li>';
      }
      
      $output .= '</ul>';
      $output .= '<input type="hidden" name="sort_order" id="sort_order" />';
    }
    else {
      $output .= '';
    }
    
    echo $output;
    
    $app->close();
  }
  
  function uploadfiles() {
    
    $app = JFactory::getApplication();
    $db		= JFactory::getDbo();
    
    $params = JComponentHelper::getParams('com_urednideska');
    $pid = JRequest::getInt('pid', 0);
    
    $folder = $params->get('adresar', 'dokumenty'.DS);
    $destpath = JPATH_ROOT.DS.$folder;
    
    if (!JFolder::exists($destpath)) {
      JFolder::create($destpath);
    }
        
		$query	= $db->getQuery(true);
    
/*    $max_upload 	= self::_convert_size(ini_get('upload_max_filesize'));
	  $max_post 		= self::_convert_size(ini_get('post_max_size'));
	  $memory_limit = self::_convert_size(ini_get('memory_limit'));
	  
	  $limit = min($max_upload, $max_post, $memory_limit); */
	      
	  // Read headers
	  $response = array();
		$headers 	= UrednideskaHelper::read_headers();
    		
		$response['id']    	= $headers['X-File-Id'];
//	  $response['name']  	= basename($headers['X-File-Name']); 	// Basename for security issues
    $response['filename'] = JRequest::getVar('filename', '', '', 'string');
	  $response['size']  	= $headers['Content-Length'];
	  $response['error'] 	= UPLOAD_ERR_OK; 
	  $response['finish'] = FALSE;
	    
	  // Detect upload errors
/*		if ($response['size'] > $limit) 
	    $response['error'] = UPLOAD_ERR_INI_SIZE; */
					          	  
    $nazevSouboru = strtolower(JFile::stripExt($response['filename']));
    $priponaSouboru = strtolower(JFile::getExt($response['filename']));
    $filename = $pid.'-'.JFilterOutput::stringURLSafe($nazevSouboru).'.'.$priponaSouboru;
	  
	  $response['upload_name'] = $filename;
    
    // Is resume?	  
		$resume = ($headers['X-File-Resume'] == 'true') ? FILE_APPEND : 0;
	    
	  // Write file
		if (file_put_contents($destpath.$filename, file_get_contents('php://input'), $resume) === FALSE) {
	    $response['error'] = UPLOAD_ERR_CANT_WRITE;
    }
	  else {
	    if (filesize($destpath.$filename) == $headers['X-File-Size']) {
        $response['finish'] = TRUE;

        $query->clear();
        $query->select('COUNT(*)');
		    $query->from('#__urednideska_files');
		    $query->where('pid = '.$pid);

		    // Get the options.
		    $db->setQuery($query);

		    $fileorder = $db->loadResult() + 1;
        
        $query->clear();
        $query->select('*');
		    $query->from('#__urednideska_files');
		    $query->where('pid = '.$pid.' AND filename = '.$db->quote(JFilterOutput::stringURLSafe($nazevSouboru)));

		    // Get the options.
		    $db->setQuery($query);

		    $count = $db->getCount();

        if ($count == 0) {
          $query->clear();
          $query->insert($db->quoteName('#__urednideska_files'));
          $query->columns(array($db->quoteName('pid'), $db->quoteName('file'), $db->quoteName('filename'), $db->quoteName('extension'), $db->quoteName('ordering')));
		      $query->values($db->quote($pid).', '.$db->quote($response['filename']).', '.$db->quote(JFilterOutput::stringURLSafe($nazevSouboru)).', '.$db->quote($priponaSouboru).', '.$db->quote($fileorder));
		      $db->setQuery($query);
		      $db->query();
          
          // Check for a database error.
		      if ($db->getErrorNum()) {
            $response['error'] = $db->getErrorMsg();
		      }
        }
        else {
        }   
	    }
	  } 
	  
	  echo json_encode($response);
    
    $app->close(); 
  }
  
  function deletefile() {
    $app = JFactory::getApplication();
    $db		= JFactory::getDbo();
    $query	= $db->getQuery(true);
    
    $params = JComponentHelper::getParams('com_urednideska');
    $id = JRequest::getVar('id', '', 'get', 'int');
    
    $folder = $params->get('adresar', 'dokumenty'.DS);
    $destpath = JPATH_ROOT.DS.$folder;
    
    $query->clear();
    $query->select('*');
		$query->from('#__urednideska_files');
		$query->where('id = '.$id);

		// Get the options.
		$db->setQuery($query);
		$item = $db->loadObject();
    
    $filename = $item->pid.'-'.$item->filename.'.'.$item->extension; 
        
    $result = JFile::delete($destpath.$filename);
        
    if ($result) {
      $query->clear();
      $query->delete('#__urednideska_files');
      $query->where('id = '.$id);
      
      $db->setQuery($query);
		  $db->query();
      
      $query->clear();
      $query->update($db->quoteName('#__urednideska_files'))
        ->set(array($db->quoteName('ordering'). ' = (ordering - 1)'))
        ->where(array($db->quoteName('pid').' = '.$item->pid, $db->quoteName('ordering').' > '.$item->ordering)); 
      $db->setQuery($query); 
      $db->query();
      
      $text['message'] = 'Soubor byl smazán.';
      $text['level'] = 'ok';
      $text['query'] = $query->dump();   
    }
    else {
      $text['message'] = 'Soubor se nepodařilo smazat.<br />Kontaktujte správce.';
      $text['level'] = 'error';
    }
  
    echo json_encode($text);
    $app->close();
  }
  
  function fileorder() {
    $app = JFactory::getApplication();
    $db		= JFactory::getDbo();
    
    $sortorder = JRequest::getVar('sortorder', '', 'get', 'string');
    
    $sort = explode('|', $sortorder);
    
    for($i = 0; $i < (count($sort)-1); $i++) {
      $query	= $db->getQuery(true);
      
      $query->update($db->quoteName('#__urednideska_files'))
        ->set(array($db->quoteName('ordering').' = '. ($i+1)))
        ->where(array($db->quoteName('id').' = '.$sort[$i])); 
      $db->setQuery($query); 
      $result = $db->query(); 
    }
    $app->close();
  }
  
/*  protected function allowAdd($data = array())  {
		// Initialise variables.
		$user = JFactory::getUser();
		$categoryId = JArrayHelper::getValue($data, 'catid', 0, 'int');
		$allow = null;
    dump($allow);
		if ($categoryId)
		{
			// If the category has been passed in the data or URL check it.
			$allow = $user->authorise('core.create', 'com_content.category.' . $categoryId);
		}

		if ($allow === null)
		{
			// In the absense of better information, revert to the component permissions.
			return parent::allowAdd();
		}
		else
		{
			return $allow;
		}
	}*/
}
?>