<?php
/*------------------------------------------------------------------------
# urednidesk.php - Úřední deska Component
# ------------------------------------------------------------------------
# author    Petr Houba
# copyright Copyright (C) 2013. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   urednideska.g6.cz
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * Urednideska Table Upravakategorie class
 */
class UrednideskaTableUpravakategorie extends JTable
{
	/**
	 * Constructor
	 *
	 * @param object Database connector object
	 */
	function __construct(&$db) 
	{
		parent::__construct('#__urednideska_kategorie', 'id', $db);
	}

	/**
	 * Method to compute the default name of the asset.
	 * The default name is in the form 'table_name.id'
	 * where id is the value of the primary key of the table.
	 *
	 * @return	string
	 * @since	2.5
	 */
	protected function _getAssetName() {
		$k = $this->_tbl_key;
		return 'com_urednideska.kategorie.'.(int) $this->$k;
	}

	/**
	 * Method to return the title to use for the asset table.
	 *
	 * @return	string
	 * @since	2.5
	 */
	protected function _getAssetTitle() {
		return $this->alias;
	}

	/**
	 * Get the parent asset id for the record
	 *
	 * @return	int
	 * @since	2.5
	 */
	protected function _getAssetParentId() {
		$asset = JTable::getInstance('Asset');
		$asset->loadByName('com_urednideska');

		return $asset->id;
	}
  
  public function bind($array, $ignore = '') {
    // Bind the rules.
    if (isset($array['rules']) && is_array($array['rules'])){
      $rules = new JAccessRules($array['rules']);
      $this->setRules($rules);
    }
    
    return parent::bind($array, $ignore);
  }
}
?>