<?php
/*------------------------------------------------------------------------
# view.html.php - Úřední deska Component
# ------------------------------------------------------------------------
# author    Petr Houba
# copyright Copyright (C) 2013. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   urednideska.g6.cz
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// import Joomla view library
jimport('joomla.application.component.view');

/**
 * Kategorie View
 */
class UrednideskaViewKategorie extends JView
{
	/**
	 * display method of Kategorie view
	 * @return void
	 */
	public function display($tpl = null) {
		// Get data from the model
		$items = $this->get('Items');
		$pagination = $this->get('Pagination');
    $state = $this->get('State');

		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode('<br />', $errors));
			return false;
		}

		// Assign data to the view
		$this->items = $items;
		$this->pagination = $pagination;
    $this->state = $state;

		// Set the toolbar
		$this->addToolBar();

		// Display the template
		parent::display($tpl);

		// Set the document
		$this->setDocument();
	}


	/**
	 * Setting the toolbar
	 */
	protected function addToolBar() {
		$canDo = UrednideskaHelper::getActions();
		JToolBarHelper::title(JText::_('COM_UREDNIDESKA_KATEGORIE'), 'categories');
		if ($canDo->get('core.create')) {
			JToolBarHelper::addNew('upravakategorie.add', 'JTOOLBAR_NEW');
		}
    
		if ($canDo->get('core.edit')) {
			JToolBarHelper::editList('upravakategorie.edit', 'JTOOLBAR_EDIT');
		}
		
    if ($canDo->get('core.edit.state')) {
			JToolBarHelper::divider();
      JToolBarHelper::publish('kategorie.publish', 'JTOOLBAR_PUBLISH', true);
			JToolBarHelper::unpublish('kategorie.unpublish', 'JTOOLBAR_UNPUBLISH', true);		}
    
    if ($canDo->get('core.delete')) {
			JToolBarHelper::divider();
      JToolBarHelper::deleteList('COM_UREDNIDESKA_CATEGORIES_DELETE_CONFIRM', 'upravakategorie.delete', 'JTOOLBAR_DELETE');
		}
    
    if ($canDo->get('core.admin')) {
			JToolBarHelper::divider();
			JToolBarHelper::preferences('com_urednideska');
    }
	}

	/**
	 * Method to set up the document properties
	 *
	 * @return void
	 */
	protected function setDocument() {
		$document = JFactory::getDocument();
		$document->setTitle(JText::_('COM_UREDNIDESKA_UREDNI_DESKA_CATEGORIES'));
	}
  
  protected function pocetzaznamu($catid) {
    $db	=& JFactory::getDBO();
    $query = $db->getQuery(true);
		
		$query->select('COUNT(id)');
    $query->from($db->quoteName('#__urednideska'));
    $query->where('state = 0 AND catid = '.$catid);
    $db->setQuery((string)$query);
    $total_akt = $db->loadResult();
    		
		$query->clear();
    $query->select('COUNT(id)');
    $query->from($db->quoteName('#__urednideska'));
    $query->where('state = -1 AND catid = '.$catid);
    $db->setQuery((string)$query);
    $total_arch = $db->loadResult();
		
		return '<span title="'.JText::_( 'COM_UREDNIDESKA_ITEMS_ACTIVE_COUNT' ).'">'.$total_akt.'</span>/<span title="'.JText::_( 'COM_UREDNIDESKA_ITEMS_ARCHIVE_COUNT').'">'.$total_arch.'</span>' ;  
  }
}
?>