<?php
/*------------------------------------------------------------------------
# view.html.php - Úřední deska Component
# ------------------------------------------------------------------------
# author    Petr Houba
# copyright Copyright (C) 2013. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   urednideska.g6.cz
-------------------------------------------------------------------------*/

defined('_JEXEC') or die;

/**
 * Upravakategorie View
 */
class UrednideskaViewUpravakategorie extends JViewLegacy {
	protected $form;
	protected $item;
	protected $state;

	/**
	 * Display the view
	 */
	public function display($tpl = null) {
		$app = JFactory::getApplication();
    
    $this->state	= $this->get('State');
		$this->item		= $this->get('Item');
		$this->form		= $this->get('Form');
    
    $this->canDo	= UrednideskaHelper::getActions($this->item->id);
    
    if(!$this->canDo->get('core.edit')) {
      $app->enqueueMessage(JText::_('COM_UREDNIDESKA_PERMISSION_CATEGORIES_EDIT'), 'notice');
      $link = 'index.php?option=com_urednideska&view=kategorie';
      $app->redirect($link);
    }
    
		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
    
		$this->addToolbar();
		parent::display();
	}

	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addToolbar()
	{
		JRequest::setVar('hidemainmenu', true);

		$user		= JFactory::getUser();
		$userId		= $user->get('id');
		$isNew		= ($this->item->id == 0);
		$checkedOut	= !($this->item->checked_out == 0 || $this->item->checked_out == $user->get('id'));
		// Since we don't track these assets at the item level, use the category id.
		$canDo		= UrednideskaHelper::getActions($this->item->id);

		if (empty($this->item->id)) {
      JToolBarHelper::title(JText::_('COM_UREDNIDESKA_CATEGORIES_DETAILS_ADD'), 'category-add');
    }
    else {
      JToolBarHelper::title(JText::_('COM_UREDNIDESKA_CATEGORIES_DETAILS_EDIT'), 'category-edit');
    }

		// If not checked out, can save the item.
		if (!$checkedOut && ($canDo->get('core.edit') || (count($user->getAuthorisedCategories('com_urednideska', 'core.create')))))
		{
			JToolBarHelper::apply('upravakategorie.apply');
			JToolBarHelper::save('upravakategorie.save');
		}
		
		if (empty($this->item->id)) {
			JToolBarHelper::cancel('upravakategorie.cancel');
		}
		else {
			JToolBarHelper::cancel('upravakategorie.cancel', 'JTOOLBAR_CLOSE');
		}
	}
}
