<?php
/*------------------------------------------------------------------------
# view.html.php - Úřední deska Component
# ------------------------------------------------------------------------
# author    Petr Houba
# copyright Copyright (C) 2013. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   urednideska.g6.cz
-------------------------------------------------------------------------*/

defined('_JEXEC') or die;

/**
 * Upravazaznamu View
 */
class UrednideskaViewUpravazaznamu extends JViewLegacy {
	protected $form;
	protected $item;
	protected $state;
  protected $canDo;

	/**
	 * Display the view
	 */
	public function display($tpl = null) {
		JHtml::_('behavior.tooltip');
    JHtml::_('behavior.formvalidation');
    JHtml::_('behavior.keepalive');
    
    $doc = Jfactory::getDocument();
    
    $doc->addScript(JURI::base(true).'/components/com_urednideska/assets/js/MooUpload.js');
    $doc->addStyleSheet(JURI::base(true).'/components/com_urednideska/assets/css/MooUpload.css');
    
    $this->state	= $this->get('State');
		$this->item		= $this->get('Item');
		$this->form		= $this->get('Form');
    $this->canDo = UrednideskaHelper::getActions($this->item->catid, $this->item->id);
    
		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}
    
		$this->addToolbar();
		parent::display();
	}

	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addToolbar()
	{
		JRequest::setVar('hidemainmenu', true);

		$user = JFactory::getUser();
		$userId = $user->get('id');
		$isNew = ($this->item->id == 0);
		$checkedOut	= !($this->item->checked_out == 0 || $this->item->checked_out == $user->get('id'));
    
		if ($isNew) {
      JToolBarHelper::title(JText::_('COM_UREDNIDESKA_ITEM_DETAILS_ADD'), 'category-add');
    }
    else {
      JToolBarHelper::title(JText::_('COM_UREDNIDESKA_ITEM_DETAILS_EDIT'), 'category-edit');
    }
	
    // For new records, check the create permission.
		if ($isNew) {
			if ($this->canDo->get('core.create')) {
        JToolBarHelper::apply('upravazaznamu.apply');
        JToolBarHelper::save('upravazaznamu.save');
      }
      JToolBarHelper::cancel('upravazaznamu.cancel');
		}
    else {
      if ($this->canDo->get('core.edit') || $this->canDo->get('core.edit.own')) {
        JToolBarHelper::apply('upravazaznamu.apply');
		    JToolBarHelper::save('upravazaznamu.save');
      }
      JToolBarHelper::cancel('upravazaznamu.cancel', 'JTOOLBAR_CLOSE');
		}

		/*if (empty($this->item->id)) {
			JToolBarHelper::cancel('upravazaznamu.cancel');
		}
		else {
			JToolBarHelper::cancel('upravazaznamu.cancel', 'JTOOLBAR_CLOSE');
		}*/
	}
}
