<?php
/*------------------------------------------------------------------------
# view.html.php - Úřední deska Component
# ------------------------------------------------------------------------
# author    Petr Houba
# copyright Copyright (C) 2013. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   urednideska.g6.cz
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// import Joomla view library
jimport('joomla.application.component.view');

/**
 * urednideska View
 */
class UrednideskaViewUrednideska extends JView {
	
  protected $canDo;
  /**
	 * Urednideska view display method
	 * @return void
	 */
	function display($tpl = null) {
		$this->canDo = UrednideskaHelper::getActions();
    
    // Get data from the model
		$items = $this->get('Items');
		$pagination = $this->get('Pagination');
    $state = $this->get('State');
    $categories = $this->get('Categories');

		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode('<br />', $errors));
			return false;
		}

		// Assign data to the view
		$this->items = $items;
		$this->pagination = $pagination;
    $this->state = $state;
    $this->installInfo = UrednideskaHelper::getInstallInfo();
    $this->files = $this->files();

		// Set the toolbar
		$this->addToolBar();
    
    //List anotace
    $anotace = array();
    $anotace[] = JHtml::_('select.option',  1, JText::_('COM_UREDNIDESKA_VIEW_ANNOTATION'));
    $anotace[] = JHtml::_('select.option',  0, JText::_('COM_UREDNIDESKA_HIDE_ANNOTATION'));
    $this->list->anotace = $anotace;
    
    //List items
    $archive = array();
    $archive[] = JHtml::_('select.option',  '', JText::_('COM_UREDNIDESKA_ALL_ITEMS'));
    $archive[] = JHtml::_('select.option',  0, JText::_('JCURRENT'));
		$archive[] = JHtml::_('select.option',  -1, JText::_('JARCHIVED'));
    $this->list->archive = $archive;
    
    //List categories
    $option = array();
    $option[] = JHTML::_('select.option',  '', JText::_('COM_UREDNIDESKA_SELECT_CATEGORY'));
    foreach ($categories AS $category) {
      $option[] = JHTML::_('select.option', $category->value, $category->text);
    }
    $this->list->category = $option;

		// Display the template
		parent::display($tpl);

		// Set the document
		$this->setDocument();
	}

	/**
	 * Setting the toolbar
	 */
	protected function addToolBar() {
		JToolBarHelper::title(JText::_('COM_UREDNIDESKA_UREDNI_DESKA').'&nbsp;&nbsp;<span style="font-size: small;">'.$this->installInfo['version'].'</span>', 'urednideska');
		
    if ($this->canDo->get('core.create')) {
			JToolBarHelper::addNew('upravazaznamu.add', 'JTOOLBAR_NEW');
		}
    
		if ($this->canDo->get('core.edit')) {
			JToolBarHelper::editList('urednideska.edit', 'JTOOLBAR_EDIT');
		}
		
    if ($this->canDo->get('core.edit.state')) {
			JToolBarHelper::divider();
			JToolBarHelper::archiveList('urednideska.archive');
      JToolBarHelper::unarchiveList('urednideska.unarchive');
		}
    
    if ($this->canDo->get('core.delete')) {
			JToolBarHelper::divider();
      JToolBarHelper::deleteList('', 'upravazaznamu.delete', 'JTOOLBAR_DELETE');
		}
    
		if ($this->canDo->get('core.admin')) {
			JToolBarHelper::divider();
			JToolBarHelper::preferences('com_urednideska');
    }
	}

	/**
	 * Method to set up the document properties
	 *
	 *
	 * @return void
	 */
	protected function setDocument() {
		$document = JFactory::getDocument();
		$document->setTitle(JText::_('COM_UREDNIDESKA_UREDNI_DESKA_ADMINISTRATOR'));
	}
  
  protected function files () {
		$db	=& JFactory::getDBO();
    $query = $db->getQuery(true);
    
    $query->select('*');
    $query->from('#__urednideska_files');
    $query->where('1');
    $query->order('pid, ordering');
    
    $db->setQuery($query->__toString());
    $files = $db->loadObjectList();
    
    return $files;    
  }
  
  protected	function soubor ($id, $file, $filename, $extension) {
    $dir = JPATH_ROOT.DS.$this->params->get('adresar', 'dokumenty/');
    $nazevSouboru = $id.'-'.$filename.'.'.$extension;
    
    if (JFile::exists($dir.$nazevSouboru)) {
      $filesize = filesize($dir.$nazevSouboru);
    }
    else {
      return false;
    }    
    
    $output = '<a href="../'.$this->params->get('adresar', 'dokumenty/').$nazevSouboru.'" target="'.$this->params->get( 'link', '_blank').'">'.UrednideskaHelper::ikona ($extension, $file).'</a>';
    $output .= ' ['.UrednideskaHelper::format_bytes($filesize).']';

    return $output;  
	}
}
?>