<?php
/*------------------------------------------------------------------------
# script.php - Úřední deska Component
# ------------------------------------------------------------------------
# author    Petr Houba
# copyright Copyright (C) 2013. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   urednideska.g6.cz
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport('joomla.installer.installer');
jimport('joomla.installer.helper');

/**
 * Script file of Úřední deska component
 */
class com_urednideskaInstallerScript
{
	/**
	 * method to install the component
	 *
	 *
	 * @return void
	 */
	function install($parent)
	{

	}

	/**
	 * method to uninstall the component
	 *
	 * @return void
	 */
	function uninstall($parent)
	{

	}

	/**
	 * method to update the component
	 *
	 * @return void
	 */
	function update($parent) {
    if (version_compare($this->oldRelease, '2.0beta4', 'lt')) {
      $db = JFactory::getDBO();
      $query = $db->getQuery(true);
      
      $query->select($db->quoteName(array('id', 'pid')));
      $query->from($db->quoteName('#__urednideska_files'));
      $query->where('1');
      $query->order('pid ASC, file ASC');

      $db->setQuery($query);
      $rows = $db->loadObjectList();
      
      $ordering = 0;
      $item = '';
      foreach($rows AS $row) {
        if($item != $row->pid) {
          $ordering = 1;
        }
        else {
          $ordering++;
        }
        
        $query = $db->getQuery(true);
        $query->update($db->quoteName('#__urednideska_files'));
        $query->set($db->quoteName('ordering').' = '.$db->quote($ordering));
        $query->where($db->quoteName('id') . ' = ' . $db->quote($row->id)); 

        $db->setQuery($query);
        $db->query();
        
        $item = $row->pid;
      }  
    } 
	}

	/**
	 * method to run before an install/update/uninstall method
	 *
	 * @return void
	 */
	function preflight($type, $parent) {
    $jversion = new JVersion();

		// Installing component manifest file version
		$this->release = $parent->get("manifest")->version;
		
		// Manifest file minimum Joomla version
		$this->minimum_joomla_release = $parent->get( "manifest" )->attributes()->version;   

		// abort if the current Joomla release is older
		if( version_compare( $jversion->getShortVersion(), $this->minimum_joomla_release, 'lt' ) ) {
			Jerror::raiseWarning(null, 'Cannot install com_urednideska in a Joomla release prior to '.$this->minimum_joomla_release);
			return false;
		}
 
		// abort if the component being installed is not newer than the currently installed version
		if ($type == 'update') {
			$this->oldRelease = $this->getParam('version');
			$rel = $this->oldRelease.' na '.$this->release;
			if (version_compare($this->release, $this->oldRelease, 'le')) {
				Jerror::raiseWarning(null, 'Špatná verze. Není možné aktualizovat verzi '.$rel);
				return false;
			}
		}
		else {
      $rel = $this->release;
    }
	}

	/**
	 * method to run after an install/update/uninstall method
	 *
	 * @return void
	 */
	function postflight($type, $parent) {
    if ($type == 'install') {
      $db = JFactory::getDBO();
      $query = $db->getQuery(true);
      $query->update($db->quoteName('#__extensions'));
      $defaults = '{"doba_vyveseni":"15","aut_archivace":"0","adresar":"dokumenty\/","mazat_archiv":"0","povolene_pripony":"jpg,gif,pdf,doc,docx,xls,xlsx","intro":"","theme":"default","sablona_aktualni":"kat","razeni_kategorie":"title_asc","sablona_archiv":"date","platnost":"","link":"_blank","ikona":"0","hits":"0","sloupec1":"","sloupec1param":"0","sloupec2":"","sloupec2param":"0","subscribe":"0","sablona_file_size":"1"}'; // JSON format for the parameters
      $query->set($db->quoteName('params') . ' = ' . $db->quote($defaults));
      $query->where($db->quoteName('name') . ' = ' . $db->quote('com_urednideska')); 
      $db->setQuery($query);
      $db->query();
    } 
	}
  
  function getParam($name) {
		$db = JFactory::getDbo();
		$db->setQuery('SELECT manifest_cache FROM #__extensions WHERE name = "com_urednideska"');
		$manifest = json_decode($db->loadResult(), true);
		
    return $manifest[$name];
	}
}
?>