<?php
/*------------------------------------------------------------------------
# urednideska.php - Úřední deska Component
# ------------------------------------------------------------------------
# author    Petr Houba
# copyright Copyright (C) 2013. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   urednideska.g6.cz
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * Urednideska component helper
 */
abstract class UrednideskaHelper {
  public function fdatum($datum) {
    $datum = StrFTime('%d.%m.%Y', strtotime($datum));
    $datum = str_replace('.0', '.', $datum);
    $num = strlen($datum);
    if(substr($datum, 0, 1) == '0') $datum = substr($datum, 1, $num);

    return $datum;
  
  }
  
  public function files($pid = 0) {
		$db	=& JFactory::getDBO();
    
    if ($pid > 0) {
      $where = ' WHERE pid = '.$pid;
    }
    else {
      $where = ' WHERE 1';
    }
    
    $query = 'SELECT *'
			. ' FROM #__urednideska_files'
			. $where 
      . ' ORDER BY pid, ordering'
		;

    $db->setQuery( $query );
    $files = $db->loadObjectList();
    
    return $files;    
  }
  
  public function soubor ($id, $file, $filename, $extension, $link, $hits) {
    $params = JComponentHelper::getParams ('com_urednideska');
    $hits1 = '';
    
    $dir = JPATH_SITE.DS.$params->get('adresar'); 
    $nazevSouboru = $id.'-'.$filename.'.'.$extension;
    $filesize = filesize($dir.$nazevSouboru);
    
    if ($params->get('hits') == 1) $hits1 = ' <em>('.$hits.'x)</em>';   

    $output = '<a href="'.$link.'" target="'.$this->params->get('link').'">'.urednideskaHelper::ikona($extension, $file, $params->get('ikona')).'</a>';
    
    if ($params->get('sablona_file_size', 1) == 1) {
      $output .= ' ['.urednideskaHelper::format_bytes($filesize).']';  
    }
    
    $output .= $hits1;
    return $output;  
	}
  
  public function soubor1 ($id, $file, $filename, $extension, $link, $hits) {
    $params = JComponentHelper::getParams ('com_urednideska');
    $hits1 = '';
    
    $dir = JPATH_SITE.DS.$params->get('adresar'); 
    $nazevSouboru = $id.'-'.$filename.'.'.$extension;
    $filesize = filesize($dir.$nazevSouboru);

    if ($params->get('hits') == 1) $hits1 = ' <em>('.$hits.'x)</em>';   

    $output = '<a href="'.$link.'" target="'.$this->params->get('link').'">'.urednideskaHelper::ikona($extension, $file, $params->get('ikona')).'</a>';
    $output .= ' <a href="'.$link.'" target="'.$params->get( 'link').'">'.$file.'</a>';
    
    if ($params->get('sablona_file_size', 1) == 1) {
      $output .= ' ['.urednideskaHelper::format_bytes($filesize).']';  
    }
    
    $output .= $hits1;
    
    return $output;  
	}
  
  public function ikona ($extension, $name, $ikona) {
    if ($ikona == 0) {
      $text = '<span class="hasTip" title="'.JText::_('COM_UREDNIDESKA_SHOW_FILE').'">'.$extension.'</span>'; 
      return $text;  
    }   
    
    switch ($extension) {
      case 'doc':
      case 'docx':
        $file = 'doc.gif';
      break;
      case 'xls':
      case 'xlsx':
        $file = 'xls.gif';
      break;
      case 'jpg':
      case 'gif':
        $file = 'jpg.gif';
      break;
      case 'txt':
        $file = 'txt.gif';
      break;
      case 'pdf':
        $file = 'pdf.gif';
      break;
      case 'zip':
        $file = 'zip.gif';
      break;
      default:
        $file = 'default.gif'; 
    }

    $image = '<img class="hasTip" src="'.JURI::base().'administrator/components/com_urednideska/assets/images/icons/'.$file.'" align="bottom" title="'.JText::_('COM_UREDNIDESKA_SHOW_FILE').'" alt="'.JText::_('COM_UREDNIDESKA_SHOW_FILE').'" />'; 
    return $image;
  }
  
  public function format_bytes($size) {
    $units = array(' B', ' kB', ' MB', ' GB', ' TB');
    for ($i = 0; $size >= 1024 && $i < 4; $i++) {
      $size /= 1024;
    }
    
    return str_replace('.',',',round($size, 0)).$units[$i];
  }
  
  public function getInstallInfo() { 
    $xml_items = '';
    if ($data = JApplicationHelper::parseXMLInstallFile(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_urednideska'.DS.'urednideska.xml')) {
      foreach($data as $key => $value) {
        $xml_items[$key] = $value;
      }
    }
        
    return $xml_items;
  }
  
  public function stringtodate($date) {
    $date = explode('.', $date);

/*    $day = substr($date,0,2);
    $month = substr($date,3,2);
    $year = substr($date,6,4);*/
    
    
    return trim($date[2]).'-'.trim($date[1]).'-'.trim($date[0]); 
  }
}
?>