<?php
/*------------------------------------------------------------------------
# urednideska.php - Úřední deska Component
# ------------------------------------------------------------------------
# author    Petr Houba
# copyright Copyright (C) 2013. All Rights Reserved
# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
# website   urednideska.g6.cz
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');
// import the Joomla modellist library
jimport('joomla.application.component.modellist');
/**
 * Urednideska Model
 */
class UrednideskaModelUrednideska extends JModelList {
	public function __construct($config = array()) {
    
    $this->search = $this->getUserStateFromRequest('urednideska.filter.search', 'filter_search', '', 'string');
//		$this->setState('filter.search', $search);
    $this->publish_up = $this->getUserStateFromRequest('urednideska.filter.publish_up', 'publish_up', '', 'string');
//		$this->setState('filter.publish_up', $publish_up);
    $this->publish_down = $this->getUserStateFromRequest('urednideska.filter.publish_down', 'publish_down', '', 'string');
//		$this->setState('filter.publish_down', $publish_down);
    $this->category = $this->getUserStateFromRequest('urednideska.filter.category', 'filter_category', '', 'string');
//		$this->setState('filter.category', $category);*/

		parent::__construct($config);
	}
  
  function getActualItems() {
		$db = JFactory::getDBO();
    $params = JComponentHelper::getParams ('com_urednideska');
        
		$query = $db->getQuery(true);

		$query->select('ud.*');
		// From the urednideska table
		$query->from('#__urednideska AS ud');
    
    // Join over the categories
		$query->select('k.title AS catitle, k.description AS catdescription');
		$query->join('LEFT', $db->quoteName('#__urednideska_kategorie').' AS k ON ud.catid = k.id');
    
    // Join over the users
		$query->select('u.name AS zodpovida');
		$query->join('LEFT', $db->quoteName('#__users').' AS u ON ud.created_by = u.id');
    
    $query->where('(k.published = 1 || ud.catid = 0) AND ud.state = 0');
    
    if(!empty($this->search)) {
      $query->where('(ud.title LIKE '.$db->quote('%'.$this->search.'%').' || ud.fulltext LIKE '.$db->quote('%'.$this->search.'%').')');
    }
    
    if(!empty($this->publish_up)) {
      $query->where('ud.publish_up >= '.$db->quote(UrednideskaHelper::stringtodate($this->publish_up)));
    }
    
    if(!empty($this->publish_down)) {
      $query->where('(ud.publish_down <= '.$db->quote(UrednideskaHelper::stringtodate($this->publish_down)).' || ud.publish_down LIKE '.$db->quote('0000-00-00').')');
    }
    
    if(!empty($this->category)) {
      $query->where('k.id = '.$db->quote($this->category));
    }
    
    switch ($params->get('razeni_kategorie')) {
      case 'title_asc':
        $query->order('k.title ASC');
        break;

      case 'title_desc':
        $query->order('k.title DESC');
        break;

      case 'ordering':
        $query->order('k.ordering ASC');
        break;    
    }
    
    //echo $query->dump();
    $db->setQuery($query);
    $rows = $db->loadObjectList();
    
		return $rows;
	}
  
  function getArchiveItems() {
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);

		$query->select('ud.*');
		// From the urednideska table
		$query->from('#__urednideska AS ud');
    
    // Join over the categories
		$query->select('k.title AS catitle');
		$query->join('LEFT', $db->quoteName('#__urednideska_kategorie').' AS k ON ud.catid = k.id');
    
    // Join over the users
		$query->select('u.name AS zodpovida');
		$query->join('LEFT', $db->quoteName('#__users').' AS u ON ud.created_by = u.id');
    
    $query->where('(k.published = 1 || ud.catid = 0) AND ud.state = -1');
    $query->order('ud.publish_down DESC, k.title');
    
    if(!empty($this->search)) {
      $query->where('(ud.title LIKE '.$db->quote('%'.$this->search.'%').' || ud.fulltext LIKE '.$db->quote('%'.$this->search.'%').')');
    }
    
    if(!empty($this->publish_up)) {
      $query->where('ud.publish_up >= '.$db->quote(UrednideskaHelper::stringtodate($this->publish_up)));
    }
    
    if(!empty($this->publish_down)) {
      $query->where('(ud.publish_down <= '.$db->quote(UrednideskaHelper::stringtodate($this->publish_down)).' || ud.publish_down LIKE '.$db->quote('0000-00-00').')');
    }
    
    if(!empty($this->category)) {
      $query->where('k.id = '.$db->quote($this->category));
    }

    $db->setQuery($query);
    $rows = $db->loadObjectList();
    
		return $rows;
	}
  
  /**
  * Build a list of categories
  *
  * @return	JDatabaseQuery
  */
  public function getCategories() {
		// Create a new query object.
		$db = $this->getDbo();
		$query = $db->getQuery(true);

		// Construct the query
		$query->select('k.id AS value, k.title AS text');
		$query->from('#__urednideska_kategorie AS k');
		$query->where('k.published = 1');
    $query->order('k.title');

		// Setup the query
		$db->setQuery($query->__toString());

		// Return the result
		return $db->loadObjectList();
	}
}
?>